/**
 * @PROJECT			CGI Bash Shell Interface
 * @COPYRIGHT		See COPYING in the top level directory
 * @FILE			mimetype.h
 * @PURPOSE			Mimetype and file upload handler
 * @DEVELOPERS		Nathan Angelacos <nangel@users.sourceforge.net>
 *					Rafal Kupiec <belliash@asiotec.eu.org>
 */

#ifndef __MIMETYPE_H
#define __MIMETYPE_H

typedef struct {
	char* name;
	char* filename;
	char* type;
	char* tempname;
	buffer_t value;
	int fh;
} mime_var_t;

void empty_stdin(void);
void mime_exec(mime_var_t* obj, char* fifo);
char* mime_substr(char* start, int len);
void mime_tag_add(mime_var_t* obj, char* str);
void mime_var_destroy(mime_var_t* obj);
void mime_var_init(mime_var_t* obj);
void mime_var_open_target(mime_var_t* obj);
void mime_var_putenv(list_t* env, mime_var_t* obj);
void mime_var_writer(mime_var_t* obj, char* str, int len);
int rfc2388_handler(list_t* env);

#endif
